unit PulseInUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TPulseInForm = class(TForm)
    InBitModeRadios: TRadioGroup;
    PollTime: TTimer;
    IOGroupA: TGroupBox;
    InBitPulseLabelA0: TLabel;
    InBitFreqLabelA0: TLabel;
    InBitLabelA0: TLabel;
    InBitPulseLabelA1: TLabel;
    InBitFreqLabelA1: TLabel;
    InBitLabelA1: TLabel;
    InBitPulseLabelA2: TLabel;
    InBitFreqLabelA2: TLabel;
    InBitLabelA2: TLabel;
    InBitPulseLabelA3: TLabel;
    InBitFreqLabelA3: TLabel;
    InBitLabelA3: TLabel;
    InBitPulseLabelA4: TLabel;
    InBitFreqLabelA4: TLabel;
    InBitLabelA4: TLabel;
    InBitPulseLabelA5: TLabel;
    InBitFreqLabelA5: TLabel;
    InBitLabelA5: TLabel;
    InBitPulseLabelA6: TLabel;
    InBitFreqLabelA6: TLabel;
    InBitLabelA6: TLabel;
    InBitPulseLabelA7: TLabel;
    InBitFreqLabelA7: TLabel;
    InBitLabelA7: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure PollTimeTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  protected
    InBitControl: array[0..15] of record
      PulseLabel, FreqLabel: TLabel;
    end;

    procedure CreateParams(var Params: TCreateParams); override;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PulseInForm: TPulseInForm;

implementation

{$R *.DFM}

uses
  AIOWDM,
  SampleGlobals;

{ TPulseInForm }

procedure TPulseInForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  Params.WndParent := Application.MainForm.Handle;
end;

procedure TPulseInForm.FormCreate(Sender: TObject);
begin
  LoadDefaultFont(Font);

  InBitControl[ 0].PulseLabel := InBitPulseLabelA0;
  InBitControl[ 0].FreqLabel  :=  InBitFreqLabelA0;
  InBitControl[ 1].PulseLabel := InBitPulseLabelA1;
  InBitControl[ 1].FreqLabel  :=  InBitFreqLabelA1;
  InBitControl[ 2].PulseLabel := InBitPulseLabelA2;
  InBitControl[ 2].FreqLabel  :=  InBitFreqLabelA2;
  InBitControl[ 3].PulseLabel := InBitPulseLabelA3;
  InBitControl[ 3].FreqLabel  :=  InBitFreqLabelA3;
  InBitControl[ 4].PulseLabel := InBitPulseLabelA4;
  InBitControl[ 4].FreqLabel  :=  InBitFreqLabelA4;
  InBitControl[ 5].PulseLabel := InBitPulseLabelA5;
  InBitControl[ 5].FreqLabel  :=  InBitFreqLabelA5;
  InBitControl[ 6].PulseLabel := InBitPulseLabelA6;
  InBitControl[ 6].FreqLabel  :=  InBitFreqLabelA6;
  InBitControl[ 7].PulseLabel := InBitPulseLabelA7;
  InBitControl[ 7].FreqLabel  :=  InBitFreqLabelA7;


  PollTime.Enabled := True;
end;

procedure TPulseInForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  PulseInForm := nil;
  Action := caFree;
end;

procedure TPulseInForm.PollTimeTimer(Sender: TObject);
  var
    iBit: Integer;
    BitOff, Period: LongWord;
    LoSide, HiSide: Word;
    bPWM: Boolean;
  Const
    BARcode = $81;
begin
  bPWM := InBitModeRadios.ItemIndex <> 0;

  for iBit := 0 to 7 do begin
    BitOff := $100 + $100 * iBit;

    //Acquire data.
    LoSide := InBAR16(CardNum, BARcode, BitOff + $20);
    HiSide := InBAR16(CardNum, BARcode, BitOff + $24);
    Period := LoSide + HiSide;

    //Display data.
    if bPWM then begin
      if (LoSide = 0) and (HiSide = 0) then
        InBitControl[iBit].PulseLabel.Caption := ''
      else
        InBitControl[iBit].PulseLabel.Caption := IntToStr(Round(100 * HiSide / (LoSide + HiSide))) + '%'
      ;
    end
    else
      InBitControl[iBit].PulseLabel.Caption := TimeIntervalToStr(HiSide / BaseClockHz) + ' / ' + TimeIntervalToStr(LoSide / BaseClockHz)
    ;

    if Period = 0 then
      InBitControl[iBit].FreqLabel.Caption := ''
    else
      InBitControl[iBit].FreqLabel.Caption := FreqToStr(BaseClockHz / Period)
    ;
  end;
end;

end.
